package com.diagbot.facade;

import com.diagbot.entity.node.Indication;
import com.diagbot.repository.IndicationRepository;
import com.diagbot.vo.IndicationPageVO;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.PageRequest;
import org.springframework.data.domain.Pageable;
import org.springframework.stereotype.Component;

/**
 * @Description:
 * @Author:zhaops
 * @time: 2020/11/17 13:53
 */
@Component
public class IndicationManFacade {
    @Autowired
    IndicationRepository indicationRepository;

    /**
     * 获取开单合理项列表
     *
     * @param indicationPageVO
     * @return
     */
    public Page<Indication> getPage(IndicationPageVO indicationPageVO) {
        Pageable pageable = PageRequest.of(indicationPageVO.getNumber(), indicationPageVO.getSize());
        Page<Indication> page = indicationRepository.getPage(indicationPageVO.getLabels(), indicationPageVO.getConceptName(), indicationPageVO.getConditionName(), pageable);
        return page;
    }
}