package com.diagbot.web;

import com.diagbot.dto.RespDTO;
import com.diagbot.entity.node.Indication;
import com.diagbot.facade.IndicationManFacade;
import com.diagbot.vo.IndicationPageVO;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.domain.Page;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

/**
 * @Description:
 * @Author:zhaops
 * @time: 2020/11/17 13:56
 */
@RestController
@RequestMapping("/indicationman")
@Api(value = "开单合理项维护相关API", tags = { "开单合理项维护相关API" })
@SuppressWarnings("unchecked")
public class IndicationManController {
    @Autowired
    IndicationManFacade indicationManFacade;

    @ApiOperation(value = "获取开单合理项列表[zhaops]",
            notes = "number:页码<br>" +
                    "size:每页条目数<br>" +
                    "labels:术语类型（多选）<br>" +
                    "conceptName:术语名称（模糊匹配）<br>" +
                    "conditionName:条件明细（模糊匹配）<br>")
    @PostMapping("/getPage")
    public RespDTO<Indication> getPage(@RequestBody IndicationPageVO indicationPageVO) {
        Page<Indication> data = indicationManFacade.getPage(indicationPageVO);
        return RespDTO.onSuc(data);
    }
}